#ifndef __GUILE_GL_SUPPORT_H__
#define __GUILE_GL_SUPPORT_H__

#define SGL_SCM2X_ARRAY_HEADER(NAME, TYPE) \
 TYPE * sgl_scm2 ## NAME ## _array (SCM obj, TYPE *array, int maxsize, int exact_size, int pos, const char *sname)


GLfloat*  sgl_scm2fe_array (SCM obj, GLfloat *array, int maxsize, sgtk_enum_info *info, int pos, char *sname);

SGL_SCM2X_ARRAY_HEADER (f, GLfloat);
SGL_SCM2X_ARRAY_HEADER (d, GLdouble);
SGL_SCM2X_ARRAY_HEADER (i, GLint);
SGL_SCM2X_ARRAY_HEADER (u, GLuint);
SGL_SCM2X_ARRAY_HEADER (s, GLshort);
SGL_SCM2X_ARRAY_HEADER (b, GLbyte);
SGL_SCM2X_ARRAY_HEADER (ub, GLubyte);

void sgl_init_GL_support_glue (void);

#endif
