/*
 *	GLU.defs
 */

typedef struct
{
  GLUtesselator		*tess;
  SCM			 protect_list;
  SCM			 callbacks;
  SCM			 callbacks_with_data;
  SCM			 data;
} TessWrap;

typedef GLUquadricObj gluQuadricObj;
typedef GLUtesselator gluTesselator;

typedef int gluDrawStyleType;
typedef int gluOrientType;
typedef int gluNormalsType;

void* gluFakeCopyQuadric (void *);
void  sglu_init_GLU_tess_glue (void);

#ifdef SCM_SMOB_PREDICATE /* New Guile */
#define SCM_TESSP(X)	SCM_SMOB_PREDICATE (tc_tess, (X))
#define SCM_TESS(X)	((TessWrap *) SCM_SMOB_DATA (X))
#else			  /* old Guile */
#define SCM_TESSP(X)	(SCM_NIMP (X) && (SCM_CAR (X) == tc_tess))
#define SCM_TESS(X)    ((TessWrap *) (SCM_CDR (X)))
#endif

#define SCM_GLU_TESSELATOR(X)  (SCM_TESS(X)->tess)

extern long		tc_tess;
