; -*- Scheme -*-

(define-module (open-gl gtkgl)
  :use-module (gtk dynlink)
  :use-module (gtk gtk)
  :use-module (open-gl gl))

(merge-compiled-code "sgtk_init_gtkgl_glue" "libguilegtkgl")

(defmacro-public with-gtk-gl-area:render! (area . body)
  `(if (gtk-gl-area-make-current ,area)
       (begin 
	 ,@body
	 (gtk-gl-area-swapbuffers ,area))
       (error "gtk-gl-area-make-current failed")))

(defmacro-public with-gtk-gl-area (area . body)
  `(if (gtk-gl-area-make-current ,area)
       (begin 
	 ,@body)
       (error "gtk-gl-area-make-current failed")))

